/*	
 *	cliptask.h
 *
 *	ȥޤ
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Fri Nov 30 14:14:09 JST 2001 Naoyuki Sawa
 *	- ϡ
 *	* Fri Nov 30 16:31:29 JST 2001 Naoyuki Sawa
 *	- 1st꡼
 */
#ifndef __CLIP_TASK_H__
#define __CLIP_TASK_H__

/*****************************************************************************
 *	TASK
 *****************************************************************************/

typedef struct _TASK TASK;

/* ϥɥΥץȥפǤ
 */
typedef void (*TASKFREEPROC)(TASK* task);	/* Freeϥɥ */
typedef int  (*TASKWORKPROC)(TASK* task);	/* Workϥɥ */
typedef void (*TASKDRAWPROC)(TASK* task);	/* Drawϥɥ */

/* 桼ζ̥إåǤ
 */
struct _TASK {
	int suspend;		/* ڥɥ */

	TASK* parent;		/* ƥ(NULL:ȥåץ٥) */
	TASK* siblings;		/* η勵(NULL:ü) */
	TASK* children;		/* ǽλҥ(NULL:ʤ) */

	TASKFREEPROC free;	/* Freeϥɥ(NULL:ʤ) */
	TASKWORKPROC work;	/* Workϥɥ(NULL:ʤ) */
	TASKDRAWPROC draw;	/* Drawϥɥ(NULL:ʤ) */
};

/* ޤ
 * [in]
 *	parent		ƥؤΥݥ󥿡
 *			NULLꤹȡȥåץ٥륿Ȥʤޤ
 *	data_size	ǡΰΥХȿ
 * [out]
 *			ؤΥݥ󥿡
 *			꤬ݤǤʤСNULL֤ޤ
 */
TASK* task_new(TASK* parent, int data_size);

/* ޤ
 * [in]
 *	task		ؤΥݥ󥿡
 */
void task_free(TASK* task);

/* Ƥλҥޤ
 * [in]
 *	task		ؤΥݥ󥿡
 */
void task_clear(TASK* task);

/* WorkϥɥƤӽФޤ
 * [in]
 *	task		ؤΥݥ󥿡
 * [note]
 *			Workϥɥ餬0֤顢
 *			ơδؿ0֤ޤ
 *			Workϥɥ餬0ʳ֤ͤ顢
 *			δؿ0ʳ֤ͤޤ
 */
int task_work(TASK* task);

/* DrawϥɥƤӽФޤ
 * [in]
 *	task		ؤΥݥ󥿡
 */
void task_draw(TASK* task);

/* ꥹȤ˴ޤޤ륿οޤ
 * [in]
 *	task		ؤΥݥ󥿡
 * [out]
 *			ο
 * [note]
 *	* οˤϡ˻ꤷtaskȤޤޤޤ
 *	  äơtaskNULLǤʤ¤ꡢͤ1ʾˤʤޤ
 *	  taskNULLꤷΤߡͤ0ˤʤޤ
 */
int task_count(TASK* task);

#endif /*__CLIP_TASK_H__*/

