/*
 *	main.c
 *
 *	* Tue Dec 13 21:10:00 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

extern unsigned char _def_vbuff[DISP_X * DISP_Y]; /* zVRAM */
#define vbuff _def_vbuff

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

char state[(N_STATES + 7) / 8];	/* Xe[g */
TASK* root_task;		/* [g^XN */
TASK* game_task;		/* Q[^XN */
int timer;			/* ^C} */
int pad;			/* pbh */
FIELD fields[2];		/* tB[h(0:P1/1:P2) */
CELL next[2][2];		/* NEXTZ */
unsigned short next_seed;	/* NEXT_V[h */

/****************************************************************************
 *	[Jϐ
 ****************************************************************************/

static int save0000;		/* NULL|C^݌op */
static char heap[0x2000];	/* malloc()pq[v̈(8KB) */
static int sbuff[pclSpriteWork(N_SPRITES)];	/* XvCg[N */

/****************************************************************************
 *	initialize
 ****************************************************************************/

void
initialize()
{
	pceLCDDispStop();

	/* NULL|C^݌ô߂ɁA[Ԓn̓eۑ܂B
	 * BIOS ver1.12ł́A̕ɂNULL|C^R[op̃R[h
	 *	xjp	biCall0_ent
	 * Ă܂B(ext;ext;jṕAext;ext̕)
	 */
	save0000 = *(int*)NULL;

	/* ̃vO͕`ɃXvCgCuĝŁAzVRAM̐ݒ͕Kv܂񂪁A
	 * zVRAMݒ肵ĂȂƁASTARTŃj[ֈڍsAAƂɃG[ƂȂ܂B
	 * h߂ɁAzVRAMݒ肵Ă܂B
	 */
	pceLCDSetBuffer(vbuff);

	/* t[[gݒ肵܂B */
	pceAppSetProcPeriod(1000 / FPS);

	/* I[gs[g͎g܂B */
//	pcePadSetTrigMode(PP_MODE_SINGLE);

	/* XvCgCu܂B */
	pclSpriteInit((int*)PATTERN, sbuff, sizeof sbuff);

	/* TEh܂B */
	sound_init();

	/* q[v̈܂B */
	ansi_InitMalloc((int)heap, (int)heap + sizeof heap);

	/* [g^XN쐬܂B */
	root_task = task_new(NULL, 0);

	/* g^XN쐬܂B */
	t_hamon();

	pceLCDDispStart();
}


/****************************************************************************
 *	finalize
 ****************************************************************************/

void
finalize()
{
}

/****************************************************************************
 *	period
 ****************************************************************************/

void
period()
{
	int i;

	/* NULL|C^݌oB */
	if(*(int*)NULL != save0000) die("Write address 0");

	/* ^XNB */
	task_work(root_task);

#if 1
///bg_printf(1, 0, 0, "%2d", task_count(root_task));
#endif

	/* XvCg`B */
	pclSpriteMakeFrame(vbuff);

	/* ʔ]GtFNgB */
	if(BTST(state, STATE_REVERSE)) {
		for(i = 0; i < DISP_X * DISP_Y / 4 / 4; i++) {
			((int*)vbuff)[i] ^= -1;
		}
	}

	/* ʓ]B */
	pceLCDTransDirect(vbuff);

	/* VXeB */
	yield();

	/*--- t[̐؂ڂɂȂ܂ ---*/

	/* ^C}i߂B */
	timer++;

	/* pbh擾B */
	pad = pcePadGet();
}

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	int retval;

	/* B */
	initialize();

	/* C[vB */
	for(;;) {
		/* f[vB */
		retval = demo();
		period();
		if(retval == -1) {
			pceAppReqExit(0);
			yield();
			/* ւ͗܂B */
		}

		/* Q[[vB */
		game(retval);
		period();
	}

	return 0;
}

